define({'Avro':{d:'Avro is a row-oriented remote procedure call and data serialization framework developed within Apache\u0027s Hadoop project. It uses JSON for defining data types and protocols, and serializes data in a compact binary format.',l:''},'Cluster':{d:'A group of nodes, pods, or hosts.',l:''},'Common Event Format (CEF)':{d:'CEF is an open log management standard that simplifies log management, letting third parties create their own device schemas that are compatible with a standard that is used industry-wide for normalizing security events. Technology companies and customers can use the standardized CEF format to facilitate data collection and aggregation, for later analysis by an enterprise management system.',l:''},'Connector in Transformation Hub (CTH)':{d:'A feature where SmartConnector technology operates directly in Transformation Hub to collect data.',l:''},'Connectors in Transformation Hub (CTH)':{d:'CTH features enable the enriching, normalizing and sending of syslog data and routing it to Kafka topics.',l:''},'Consumer':{d:'A consumer of Transformation Hub event data. Consumers may be Micro Focus products such as Logger or ESM, third-party products like Hadoop, or can be made by customers for their own use.',l:''},'Container Deployment Foundation (CDF)':{d:'CDF is the container-based delivery and management model built on Docker containers managed by Kubernetes, which standardizes distribution, installation, upgrade, and operation of Micro Focus products and product suites.',l:''},'Containerization':{d:'Application containerization is an OS-level virtualization method used to deploy and run distributed applications without launching an entire virtual machine (VM) for each app. Multiple isolated applications or services run on a single host and access the same OS kernel.',l:''},'Dedicated Master Node':{d:'A node dedicated to running the Kubernetes control plane functionality only.',l:''},'Destination':{d:'In Micro Focus products, a forwarding location for event data. A Transformation Hub topic is one example of a destination.',l:''},'Docker Container':{d:'A Docker container is portable application package running on the Docker software development platform. Containers are portable among any system running the Linux operating system.',l:''},'Federal Information Processing Standards (FIPS)':{d:'Federal Information Processing Standards (FIPS) is a U.S. government standard used to approve cryptography modules.',l:''},'flannel':{d:'flannel (spelled with a lower-case f) is a virtual network that gives a subnet to each host for use with container runtimes.\n\nPlatforms like Google\u0027s Kubernetes assume that each container (pod) has a unique, routable IP inside the cluster. The advantage of this model is that it reduces the complexity of doing port mapping.',l:''},'Fully Qualified Domain Name (FQDN)':{d:'',l:''},'Global ESM event enrichment':{d:'With global event enrichment, the events enriched by ESM are shared with all other capabilities, including Recon and Intelligence. This configuration will benefit customers who have deployed ESM and enable maximum benefit from its capabilities.',l:''},'Hadoop Distributed File System ( HDFS )':{d:'',l:''},'Initial Master Node':{d:'The Master Node that has been designated as the primary Master Node in the cluster. It is from this node that you will install the cluster infrastructure.',l:''},'Kafka':{d:'An open-source messaging system that publishes messages for subscribers to consume on its scalable platform built to run on servers.  It is commonly referred to as a message broker.',l:''},'kubectl':{d:'The Kubernetes command line management tool. For more information on kubectl, see https://kubernetes.io/docs/reference/kubectl/overview/',l:''},'Kubernetes':{d:'Kubernetes (K8s) is an open-source system for automating deployment, scaling, and management of containerized applications.\nIt groups containers that make up an application into logical units for easy management and discovery.',l:''},'Labeling':{d:'Adding a Kubernetes label to a Master or Worker Node creates an affinity for the workload to the Master or Worker Node, enabling the node to run the specified workload on the labeled server.',l:''},'Local Docker Registry':{d:'The Docker Registry location on the Master and Worker Nodes in the  cluster.  Application software is launched and managed from the Local Docker Registry.',l:''},'Localized ESM event enrichment':{d:'With localized ESM event enrichment, capabilities such as Recon and Intelligence operate without the benefit of ESM event enrichment. A customer may use this when they have not deployed ESM, or when ESM is deployed but the value of making the enrichment data available to capabilities other than ESM is not high enough to justify the cost.  For example, there is a compute and license cost to send all events through ESM and then forward these enriched events to the other capabilities.',l:''},'Management Console (ArcMC)':{d:'The ArcSight central management console.',l:''},'Master Nodes':{d:'Master Nodes run the CDF Installer and process web services calls made to the cluster. A minimum of 1 Master Node is required for each cluster.',l:''},'Network File System (NFS)':{d:'This is the location where the CDF Installer, Transformation Hub, and other components may store persistent data. A customer-provisioned NFS is required. \nAlthough the CDF platform can host a CDF-provisioned NFS (Internal NFS), for high availability an NFS service should implemented.',l:''},'Node':{d:'A processing location. In CDF containerized applications, nodes come in two types: master and worker.',l:''},'Pod':{d:'Applications running in Kubernetes are defined as “pods”, which group containerized components. CDF uses Docker Containers as these components.  A pod consists of one or more containers that are guaranteed to be co-located on the host server and can share resources.  Each pod in Kubernetes is assigned a unique IP address within the cluster, allowing applications to use ports without the risk of conflict.',l:''},'Producer':{d:'A gatherer of event data, such as a SmartConnector or CTH. Typically data from a producer is forwarded to a destination such as a Transformation Hub topic.',l:''},'Root Installation Folder':{d:'The root installation folder is the top-level directory that the Transformation Hub, CDF Installer, and all supporting product files will be installed into.  The default setting is /opt/arcsight.\n\nIt is referred to as RootFolder in this document, supporting scripts, and installation materials.',l:''},'Shared Master and Worker Nodes':{d:'A configuration where both Master and Worker Nodes reside on the same hosts. This is not a recommended architecture for high availability.',l:''},'Single Sign-On (SSO)':{d:'SSO is an authentication scheme that allows users to log in once and access services without re-entering authentication factors.',l:''},'SmartConnector':{d:'SmartConnectors automate the process of collecting and managing logs from any device and in any format.',l:''},'Spark':{d:'Apache Spark™ is a unified analytics engine for large-scale data processing.',l:''},'StatefulSet':{d:'StatefulSet is the workload API object used to manage stateful applications.\n\nIn Kubernetes, an API object that manages the deployment and scaling of a set of pods, and provides guarantees about the ordering and uniqueness of these pods.',l:''},'Target Group':{d:'In AWS, each target group for a load balanacer is used to route requests to one or more registered targets. When you create each listener rule, you specify a target group and conditions. When a rule condition is met, traffic is forwarded to the corresponding target group. You can create different target groups for different types of requests. For example, create one target group for general requests and other target groups for requests to the microservices for your application.',l:''},'TLS Client Authentication':{d:'When enabled, the client and the server authenticate each other to ensure both parties in the communication are trusted.',l:''},'Transformation Hub':{d:'A Kafka-based messaging service that enriches and transforms security data from producers and routes this data to consumers.',l:''},'Transformation Hub cluster':{d:'The Transformation Hub cluster consists of all Master and Worker Nodes in the TH environment.',l:''},'Transport Layer Security (TLS)':{d:'Transport Layer Security (TLS) is an encryption protocol that protects Internet communications.',l:''},'Virtual IP (VIP)':{d:'To support high availability on a multi-master installation, a VIP is used as the single IP address or FQDN to connect to a dedicated Master infrastructure that contains 3 or more master Nodes.  The Master Nodes manage Worker Nodes.\n\nThe FQDN of the VIP can also be used to connect to the cluster’s Master Nodes.',l:''},'Worker Nodes':{d:'Worker nodes ingest, enrich and route events from event producers to event consumers.  Worker nodes are automatically load-balanced by the TH infrastructure.',l:''},'ZooKeeper':{d:'In Kafka, a centralized service used to maintain naming and configuration data and to provide flexible and robust synchronization within distributed systems.',l:''}});